
// 変数の定義
#include <WString.h>                 // Stringライブラリ
#include <TimerOne.h>
String inString = "                                                                        ";
String SplitCommand[2];
int OscDataCount = 0;           //オシロのデータ番号 0～511
int OscPin = 0;                 //オシロとして使うPin番号
int OscData[512];               //オシロデータ配列
void setup() {
  ////////////////////////////////////////////////////////////////////
  // put your setup code here, to run once:
  // シリアルポートを115200 bps[ビット/秒]で初期化
  Serial.begin(115200);
  pinMode(13, OUTPUT);
  Timer1.initialize();
}
void loop() {
  ////////////////////////////////////////////////////////////////////
  // put your main code here, to run repeatedly:
  SerialStringRead();
  //inString="OscTriger,0,10000";
  split(inString, SplitCommand);
  if (SplitCommand[0] == "SetPinMode") {
    SetPinMode(SplitCommand);
  }
  else if (SplitCommand[0] == "WriteDigitalOut") {
    WriteDigitalOut(SplitCommand);
  }
  else if (SplitCommand[0] == "ReadDigitalIn") {
    ReadDigitalIn(SplitCommand);
  }
  else if (SplitCommand[0] == "ReadAnalogIn") {
    ReadAnalogIn(SplitCommand);
  }
  else if (SplitCommand[0] == "OscTriger") {
    OscTriger();
  }
  else if (SplitCommand[0] == "OscDataOutput") {
    OscDataOutput();
  }
  else if (SplitCommand[0] == "OscContinuously") {
    OscContinuouslyStart();
  }
  else if (SplitCommand[0] == "OscStop") {
    OscStop();
  }
  //Serial.print(inString);
}
void SerialStringRead() {
  ////////////////////////////////////////////////////////////////////
  inString = "";
  while (true) {
    if (Serial.available()) {
      char inChar = Serial.read();     // charとして受信データを読む
      if (inChar != '\r') {
        inString = (inString + inChar);
      }
      else {
        break;
      }
    }
  }
}
void SetPinMode(String SplitCommand[]) {
  ////////////////////////////////////////////////////////////////////
  if (SplitCommand[2] == "DigitalOut") {
    pinMode(SplitCommand[1].toInt(), OUTPUT);
    //Serial.print(SplitCommand[1]);
    //Serial.print(SplitCommand[1]);
    //Serial.print(SplitCommand[2]);
  }
  else if (SplitCommand[2] == "DigitalIn") {
    pinMode(SplitCommand[1].toInt(), INPUT);
  }
  else if (SplitCommand[2] == "RDigitalIn") {
    pinMode(SplitCommand[1].toInt(), INPUT_PULLUP);
  }


}
void WriteDigitalOut(String SplitCommand[]) {
  ////////////////////////////////////////////////////////////////////
  if (SplitCommand[2] == "0" ) {
    digitalWrite(SplitCommand[1].toInt(), LOW);
  }
  else if (SplitCommand[2] == "1") {
    digitalWrite(SplitCommand[1].toInt(), HIGH);
  }
}
void ReadDigitalIn(String SplitCommand[]) {
  ////////////////////////////////////////////////////////////////////
  char s[16];
  int Val = digitalRead(SplitCommand[1].toInt());
  sprintf(s, "%d", Val);
  Serial.print(s);
}
void ReadAnalogIn(String SplitCommand[]) {
  ////////////////////////////////////////////////////////////////////
  char s[16];
  int Val = analogRead(SplitCommand[1].toInt());
  sprintf(s, "%d", Val);
  Serial.println(s);
}
void OscTriger() {
  ////////////////////////////////////////////////////////////////////
  long Interval;
  //Serial.print(SplitCommand[0]);
  //Serial.print(SplitCommand[1]);
  //Serial.print(SplitCommand[2]);
  char d[16];
  OscDataCount = 0;
  OscPin = SplitCommand[1].toInt();
  SplitCommand[2].toCharArray(d, 16);
  Interval = atol(d);
  Timer1.detachInterrupt();
  //delay(10);
  Timer1.attachInterrupt(OscPinRead, Interval);
}
void OscContinuouslyStart() {
  ////////////////////////////////////////////////////////////////////
  long Interval;
  char d[16];
  OscPin = SplitCommand[1].toInt();
  SplitCommand[2].toCharArray(d, 16);
  Interval = atol(d);
  Timer1.detachInterrupt();
  Timer1.attachInterrupt(OscContinuously, Interval);
}
void OscPinRead() {
  ////////////////////////////////////////////////////////////////////
  if (OscDataCount != 512) {
    OscData[OscDataCount] = analogRead(OscPin);
    OscDataCount++;
  }
  else {
    Timer1.detachInterrupt();
  }
}
void OscDataOutput() {
  ////////////////////////////////////////////////////////////////////
  Serial.write((byte*)OscData, 1024);
}
void split(String in, String command[]) {
  ////////////////////////////////////////////////////////////////////
  int commaIndex = in . indexOf ( ',' );
  int secondCommaIndex = in . indexOf ( ',' , commaIndex + 1 );
  command[0] = in . substring ( 0 , commaIndex );
  command[1]  = in . substring ( commaIndex + 1 , secondCommaIndex );
  command[2]  = in. substring ( secondCommaIndex + 1 );
}
void SerialSpeedTest() {
  ////////////////////////////////////////////////////////////////////
  long t0, t1;
  int d;
  char s[16];
  t0 = millis();
  Serial.write((byte*)OscData, 1024);
  t1 = millis();
  sprintf(s, "%d", t1 - t0);
  Serial.println(s);
}
void OscContinuously() {
  ////////////////////////////////////////////////////////////////////
  int d;
  d = analogRead(OscPin);
  Serial.write((byte*)&d, 2);
}
void OscStop() {
  ////////////////////////////////////////////////////////////////////
  Timer1.detachInterrupt();
}



